"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable max-len */
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var Calendar_1 = __importDefault(require("@steroidsjs/core/ui/content/Calendar"));
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
var AsideHeader_1 = __importDefault(require("./AsideHeader"));
var AsideCalendars_1 = __importDefault(require("./AsideCalendars"));
var ContentHeader_1 = __importDefault(require("./ContentHeader"));
function CalendarSystemView(props) {
    var bem = (0, useBem_1["default"])('CalendarSystemView');
    // eslint-disable-next-line react-hooks/exhaustive-deps
    var sharedFunctions = {
        getEventsFromDate: props.getEventsFromDate,
        openEditModal: props.openEditModal,
        openCreateModal: props.openCreateModal
    };
    var renderDayGrid = props.dayGridProps.renderGridView, renderWeekGrid = props.weekGridProps.renderGridView, renderMonthGrid = props.monthGridProps.renderGridView;
    var calendarTypeGrids = react_1["default"].useMemo(function () {
        var _a;
        return (_a = {},
            _a[CalendarType_1["default"].MONTH] = (react_1["default"].createElement(react_1["default"].Fragment, null, renderMonthGrid(__assign(__assign({}, props.monthGridProps), sharedFunctions)))),
            _a[CalendarType_1["default"].WEEK] = (react_1["default"].createElement(react_1["default"].Fragment, null, renderWeekGrid(__assign(__assign({}, props.weekGridProps), sharedFunctions)))),
            _a[CalendarType_1["default"].DAY] = (react_1["default"].createElement(react_1["default"].Fragment, null, renderDayGrid(__assign(__assign(__assign({}, props.dayGridProps), sharedFunctions), { users: props.users })))),
            _a);
    }, [props.dayGridProps, props.monthGridProps, props.users, props.weekGridProps, renderDayGrid, renderMonthGrid, renderWeekGrid, sharedFunctions]);
    return (react_1["default"].createElement("div", { className: bem(bem.block(), props.className), style: props.style },
        react_1["default"].createElement("aside", { className: bem.element('aside') },
            react_1["default"].createElement(AsideHeader_1["default"], { openCreateModal: props.openCreateModal, className: bem.element('aside-header') }),
            react_1["default"].createElement(Calendar_1["default"], __assign({ showFooter: false, onTodayButtonClick: props.onCalendarChangedMonth, onMonthChange: props.onCalendarChangedMonth }, props.asideCalendarProps)),
            react_1["default"].createElement(AsideCalendars_1["default"], { eventGroups: props.eventGroups, eventGroupsTitle: props.eventGroupsTitle, onChangeEventGroupsIds: props.onChangeEventGroupsIds, openCreateEventGroupModal: props.openCreateEventGroupModal })),
        react_1["default"].createElement("div", { className: bem.element('content') },
            react_1["default"].createElement(ContentHeader_1["default"], { dateToDisplay: props.dateToDisplay, handleCalendarTypeChange: props.handleCalendarTypeChange, onClickControl: props.onClickControl }),
            calendarTypeGrids[props.calendarType])));
}
exports["default"] = CalendarSystemView;
