"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var typography_1 = require("@steroidsjs/core/ui/typography");
require("./DayGrid.scss");
function DayGrid(props) {
    var _a, _b;
    var bem = (0, useBem_1["default"])('DayGrid');
    return (react_1["default"].createElement("div", { className: bem.block() },
        react_1["default"].createElement("div", { className: bem.element('content') },
            react_1["default"].createElement("div", { className: bem.element('hours-time') }, props.dayGridTwentyFourHoursArray.map(function (hour, hourIndex) { return (react_1["default"].createElement("div", { key: hourIndex, className: bem.element('hours-time-item') }, hour)); })),
            react_1["default"].createElement("div", { className: bem.element('table') },
                react_1["default"].createElement("div", { className: bem.element('table-heading'), style: {
                        gridTemplateColumns: "repeat(".concat((_a = props.users) === null || _a === void 0 ? void 0 : _a.length, ", 200px)")
                    } }, (_b = props.users) === null || _b === void 0 ? void 0 : _b.map(function (user, userIndex) { return (react_1["default"].createElement(typography_1.Text, { key: userIndex, className: bem.element('header') },
                    react_1["default"].createElement("span", { className: bem.element('header-wrapper') },
                        react_1["default"].createElement("span", { className: bem.element('header-label') }, user.name),
                        react_1["default"].createElement("span", { className: bem.element('header-caption') }, user.caption)))); })),
                react_1["default"].createElement("div", { className: bem.element('table-grid') }, props.dayGridTwentyFourHoursArray.map(function (hour, hourIndex) { return (react_1["default"].createElement("div", { key: hourIndex, className: bem.element('table-grid-row') }, props.users.map(function (user, userIndex) { return (react_1["default"].createElement(react_1["default"].Fragment, { key: userIndex }, props.renderHourView({
                    hour: hour,
                    getEventsFromDate: props.getEventsFromDate,
                    user: user,
                    openEditModal: props.openEditModal,
                    openCreateModal: props.openCreateModal,
                    currentDay: props.dayGridCurrentDay,
                    renderEventView: props.renderEventView
                }))); }))); }))))));
}
exports["default"] = react_1["default"].memo(DayGrid);
