"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable @typescript-eslint/no-shadow */
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var calendar_1 = require("@steroidsjs/core/utils/calendar");
var CalendarType_1 = __importDefault(require("@steroidsjs/core/ui/content/CalendarSystem/enums/CalendarType"));
var get_1 = __importDefault(require("lodash-es/get"));
var cloneDeep_1 = __importDefault(require("lodash-es/cloneDeep"));
require("./WeekHour.scss");
function WeekHour(props) {
    var bem = (0, useBem_1["default"])('WeekHour');
    var events = react_1["default"].useMemo(function () {
        var callingDate = new Date(props.dayOfWeek.date);
        var timeArray = props.hour.replace(':', '').split('');
        callingDate.setHours(Number(timeArray[0] + timeArray[1]), 0, 0, 0);
        var events = props.getEventsFromDate(callingDate, CalendarType_1["default"].WEEK);
        return {
            events: events
        };
    }, [props]).events;
    var handleEventClick = react_1["default"].useCallback(function (event) {
        var eventFromHour = event.target;
        var eventId = (0, get_1["default"])(eventFromHour, 'dataset.eventid');
        if (!eventId) {
            return;
        }
        var requiredEvent = events.filter(function (hourEvent) { return hourEvent.id === Number(eventId); })[0];
        props.openEditModal(requiredEvent);
    }, [events, props]);
    var handleOnContextMenuCreateClick = react_1["default"].useCallback(function (e) {
        e.preventDefault();
        var day = (0, cloneDeep_1["default"])(props.dayOfWeek);
        day.date.setHours(Number((0, calendar_1.convertDate)(props.hour, 'HH:mm', 'H')), 0, 0, 0);
        props.openCreateModal(day);
    }, [props]);
    return (react_1["default"].createElement("div", { className: bem.element('hour', {
            isToday: props.dayOfWeek.isToday
        }), onClick: handleEventClick, onContextMenu: handleOnContextMenuCreateClick }, events.map(function (event) { return props.renderEventView({
        event: event
    }); })));
}
exports["default"] = WeekHour;
